----------------------------------------------------------------------------------------------------
--   Primeiro trabalho prático de Linguagens de Programação	- Linguagem Lua						  --											 
--	 Autores: Felipe, Káio e Ruan																  --
--																								  --		
--	 Função "split" retirada de http://lua-users.org/wiki/SplitJoin , acesse para mais informações-- 
--                    																			  --
-- para compilar utilize: lua trabalho-lp.lua													  --
----------------------------------------------------------------------------------------------------

function split(pString, pPattern) -- funcao que realiza a separação das linhas por ";"
   local Table = {}  
   local fpat = "(.-)" .. pPattern
   local last_end = 1
   local s, e, cap = pString:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
     table.insert(Table,cap)
      end
      last_end = e+1
      s, e, cap = pString:find(fpat, last_end)
   end
   if last_end <= #pString then
      cap = pString:sub(last_end)
      table.insert(Table, cap)
   end
   return Table -- retorna uma tabela onde cada indice contém o conteúdo entre dois ";"
end

function pegaLinhas(arq2) -- funcao que coloca cada linha em uma posição da tabela (para depois ser utilizado o split)
  lines = {}
  for line in io.lines(arq2) do 
    lines[#lines + 1] = line
  end
  return lines
end

local arq1 = 'entregadores.csv'
local arq2 = 'cardapio.csv'
local linhas2 = pegaLinhas(arq2)
local linhas1 = pegaLinhas(arq1)

----------------------------------------------------------------------------------------------------------------------------------
entregadores = {} -- matriz de entregadores
cardapio = {} -- matriz de itens
i = 1
y = 1
for aux in io.lines("cardapio.csv") do -- preenche a tabela cardapio com os itens de entrada
	aux = split(linhas2[i], ";")
	i = i + 1
	cardapio[i] = aux
end

for aux in io.lines("entregadores.csv") do -- preenche a tabela entregadores com os itens de entrada
	aux = split(linhas1[y], ";")
	nomeEntregador = aux[1]
	y = y + 1
	entregadores[y] = nomeEntregador
end	



Clientes = {} -- tabela que armazena tabelas com as informacoes dos clientes
Pedidos = {} -- tabela que armazena os itens escolhidos pelo cliente
Relatorio = {} -- tabela que armazena os dados que serao impressos no relatorio
subtotal = 0 -- armazena o subtotal de cada pedido
total = 0 -- armazena o valor total registrado no pedido
existe = 5 -- variavel auxiliar para dizer se o cliente que esta tentando ser cadastrado existe ou nao
controlaVezEntregador = 3 -- é incrementado para saber de quem é a vez de entregar os pedidos
numeroEntregadores = #entregadores -- numero total de entregadores do disk rango

for b = 3, #entregadores do -- inicializa a tabela de Relatorios
	Relatorio[b] = {nome = entregadores[b], qtdeEntregas = 0, valorTotal = 0, comissao = 0}
	
end

while(true) do
	print("Telefone: (0 para sair)")
	telefone = io.read() -- pega o telefone
	if(telefone == "0") then break end
	
	--cliente ja existe? 0 nao, 1 sim
	if(Clientes[telefone] == nil) then existe = 0 end 
	if(Clientes[telefone] ~= nil) then existe = 1 end
	
	if(existe == 0) then -- caso onde o cliente nao está cadastrado
		print("Cliente nao cadastrado. Novo Cadastro:")
		print("Nome:")
		nome = io.read()
		print("Endereco:")
		endereco = io.read()
		print("Ponto de referencia:")
		pref = io.read()
		Clientes[telefone] = {telefone, nome, endereco, pref} -- adiciona o cliente (indexado pelo indice) na lista de clientes
		print("Cliente cadastrado: " .. nome)
		print("[C]onfirma ou [R]ecadastra?")
		opcao = io.read()
	end

	if(existe == 1) then -- cliente ja existe (Clientes[telefone] representa uma posicao valida na tabela)
		print("Cliente cadastrado: " )
		print("[C]onfirma ou [R]ecadastra?")
		opcao = io.read()
	end

	while(opcao == 'r' or opcao == 'R') do -- fica realizando o recadastro caso a opção 'R' seja escolhida
		print("Recadastrando cliente " .. telefone)
		print("Nome:")
		nome = io.read()
		print("Endereco:")
		endereco = io.read()
		print("Ponto de referencia:")
		pref = io.read()
		Clientes[telefone] = {telefone, nome, endereco, pref}
		print("Cliente cadastrado: " .. nome)
		print("[C]onfirma ou [R]ecadastra?")
		opcao = io.read()
	end
	
	if(opcao == 'c' or opcao == 'C') then -- caso a opção 'C' seja escolhida, começa a adicionar itens
		print ("Adicionar item numero (? para cardapio, 0 para finalizar):")
		codigo = io.read()
		
		
		while(codigo ~= '0') do -- while responsavel por tratar da realização de pedidos
			-- imprime cardapio, caso onde a opção é '?'
			if(codigo == '?') then
				for j = 3, #cardapio do
					print("    " .. cardapio[j][1] .. "    R$ " .. cardapio[j][4] .. "    "  .. cardapio[j][3])
				end
			end

			-- adiciona item na lista Pedidos, caso onde a opção é um item do cardápio
			itemExiste = 0
			for j = 3, #cardapio do
				if(codigo == cardapio[j][1]) then
					itemExiste = 1
					print("		" .. cardapio[j][3] .. " adicionado ao pedido. Quantidade:")
					
					-- calcula o valor parcial do pedido
					quantidade = io.read()
					subtotal = subtotal + tonumber(quantidade) * tonumber(cardapio[j][4]) -- converte de string para number e adiciona incrementa o subtotal
					
				end
				total = subtotal -- valor total do pedido
				
				-- caso onde nao encontrou o item no cardapio
				if(itemExiste == 0 and j == #cardapio and codigo ~= '?') then print("Nao ha item com codigo " .. codigo .. " no cardapio") end -- não encontrou o item
			end
			print ("Adicionar item numero (? para cardapio, 0 para finalizar):")
			codigo = io.read()
		end -- fim do while
		
		
		-- confirmacao do pedido
		print("Total: R$ " .. total )
		print("   Confirma?")
		resposta = io.read()
		
		-- resposta confirmada (passa o pedido ao entregador)
		if(resposta == 's' or resposta == 'S') then
			-- processa e atribui os dados aos indices correspondentes na tabela Relatorio
			Relatorio[controlaVezEntregador]["qtdeEntregas"] = Relatorio[controlaVezEntregador]["qtdeEntregas"] + 1 
			Relatorio[controlaVezEntregador]["comissao"] = Relatorio[controlaVezEntregador]["comissao"] + (total*0.05)
			Relatorio[controlaVezEntregador]["valorTotal"] = Relatorio[controlaVezEntregador]["valorTotal"] + total
			
			controlaVezEntregador = controlaVezEntregador + 1
			if(controlaVezEntregador == numeroEntregadores+1) then controlaVezEntregador = 3 end -- se chegou no ultimo entregador, o proximo a entregar será o primeiro
			

		end
		
		
		subtotal = 0
		total = 0
		end	
	
end -- fim do while principal

print()
print("Relatorio de entregadores:") -- ao final do programa, imprime o relatorio dos entregadores
for n = 3, numeroEntregadores do
		print(Relatorio[n]["nome"] .. ", Quantidade de Entregas: " .. Relatorio[n]["qtdeEntregas"] .. ", Valor Total: R$" .. Relatorio[n]["valorTotal"] .. ", Comissao: R$" .. Relatorio[n]["comissao"])	
end
--os.execute("pause")